searchNodes=[{"doc":"A set of tools for convenient work with RabbitMQ.Based on AMQP library.It includes:RMQ.Connection - for holding a robust connection to the server.RMQ.Consumer - for implementing consumers.RMQ.RPC - for implementing RPC via RabbitMQ.","ref":"RMQ.html","title":"RMQ","type":"module"},{"doc":"A GenServer which provides a robust connection to the RabbitMQ server.Usageiex&gt; RMQ.Connection.start_link([]) {:ok, #PID&lt;0.310.0&gt;} iex&gt; RMQ.Connection.get_connection() {:ok, %AMQP.Connection{pid: #PID&lt;0.314.0&gt;}}Configurationconfig :rmq, :connection, uri: &quot;amqp://localhost&quot;, name: &quot;MyAppConnection&quot;, reconnect_interval: 5000, username: &quot;user&quot;, password: &quot;password&quot; # ... other options for AMQP.Connection.open/3 All configuration is optional.:uri - an AMQP URI. Defaults to &quot;amqp://localhost&quot;;:connection_name - a RabbitMQ connection name. Defaults to :undefined;:reconnect_interval - a reconnect interval in milliseconds. It can be also a function that accepts the current connection attempt as a number and returns a new interval. Defaults to 5000;other options for AMQP.Connection.open/3.Dynamic configurationIn case you need to read the configuration dynamically you can use config/0 callback:defmodule MyApp.RabbitConnection do use RMQ.Connection def config do [ uri: System.get_env(&quot;RABBITMQ_URI&quot;), name: &quot;MyAppConnection&quot;, reconnect_interval: fn attempt -&gt; attempt * 1000 end # ... ] end endMultiple connectionsIf for some reason, you need to hold multiple connections you can use the following approach:defmodule MyApp.RabbitConnection1 do use RMQ.Connection, otp_app: :my_app end defmodule MyApp.RabbitConnection2 do use RMQ.Connection, otp_app: :my_app end # config.exs config :my_app, MyApp.RabbitConnection1, uri: &quot;amqp://localhost&quot;, name: &quot;MyAppConnection1&quot; config :my_app, MyApp.RabbitConnection2, uri: &quot;amqp://localhost&quot;, name: &quot;MyAppConnection2&quot;otp_app: :my_app here can be omitted and in that case otp_app: :rmq will be used.","ref":"RMQ.Connection.html","title":"RMQ.Connection","type":"behaviour"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"RMQ.Connection.html#child_spec/1","title":"RMQ.Connection.child_spec/1","type":"function"},{"doc":"Returns the configuration.","ref":"RMQ.Connection.html#config/0","title":"RMQ.Connection.config/0","type":"function"},{"doc":"A callback invoked right before connection.use RMQ.Connection will inject the default implementation of it:def config do Application.get_env(@otp_app, __MODULE__, []) endWhat can be eventually overridden into something like:def config do Keyword.merge(super(), uri: System.get_env(&quot;RABBITMQ_URI&quot;)) end","ref":"RMQ.Connection.html#c:config/0","title":"RMQ.Connection.config/0","type":"callback"},{"doc":"Gets the connection.","ref":"RMQ.Connection.html#get_connection/1","title":"RMQ.Connection.get_connection/1","type":"function"},{"doc":"Starts a GenServer process linked to the current process.","ref":"RMQ.Connection.html#start_link/1","title":"RMQ.Connection.start_link/1","type":"function"},{"doc":"Starts a GenServer process linked to the current process.","ref":"RMQ.Connection.html#start_link/2","title":"RMQ.Connection.start_link/2","type":"function"},{"doc":"RabbitMQ Consumer.Configuration:connection - the connection module which implements RMQ.Connection behaviour. Defaults to RMQ.Connection;:queue - the name of the queue to consume. Will be created if does not exist;:exchange - the name of the exchange to which queue should be bound. Also accepts two-element tuple {type, name}. Defaults to &quot;&quot;;:routing_key - queue binding key. Defaults to queue; Will be created if does not exist. Defaults to &quot;&quot;;:dead_letter - defines if the consumer should setup deadletter exchange and queue. Defaults to true;:dead_letter_queue - the name of dead letter queue. Defaults to &quot;\#{queue}_error&quot;;:dead_letter_exchange - the name of the exchange to which dead_letter_queue should be bound. Also accepts two-element tuple {type, name}. Defaults to &quot;\#{exchange}.dead-letter&quot;;:dead_letter_routing_key - routing key for dead letter messages. Defaults to queue;:concurrency - defines if consume/3 callback should be called in a separate process. Defaults to true;:prefetch_count - sets the message prefetch count. Defaults to 10;:consumer_tag - consumer tag. Defaults to a current module name;:reconnect_interval - a reconnect interval in milliseconds. It can be also a function that accepts the current connection attempt as a number and returns a new interval. Defaults to 5000;Examplesdefmodule MyApp.Consumer do use RMQ.Consumer, queue: &quot;my-app-consumer-queue&quot;, exchange: {:direct, &quot;my-exchange&quot;} @impl RMQ.Consumer def consume(chan, payload, meta) do # do something with the payload ack(chan, meta.delivery_tag) end end defmodule MyApp.Consumer2 do use RMQ.Consumer @impl RMQ.Consumer def config do [ queue: System.fetch_env!(&quot;QUEUE_NAME&quot;), reconnect_interval: fn attempt -&gt; attempt * 1000 end, ] end @impl RMQ.Consumer def consume(chan, payload, meta) do # do something with the payload ack(chan, meta.delivery_tag) end end","ref":"RMQ.Consumer.html","title":"RMQ.Consumer","type":"behaviour"},{"doc":"A callback for dynamic configuration.","ref":"RMQ.Consumer.html#c:config/0","title":"RMQ.Consumer.config/0","type":"callback"},{"doc":"A callback for consuming a message.Keep in mind that the consumed message needs to be explicitly acknowledged via AMQP.Basic.ack/3 or rejected via AMQP.Basic.reject/3. For convenience, these functions are imported and are available directly.AMQP.Basic.publish/5 is imported as well which is convenient for the case when the consumer implements RPC.When :concurrency is true this function will be executed in the spawned process using Kernel.spawn/1.","ref":"RMQ.Consumer.html#c:consume/3","title":"RMQ.Consumer.consume/3","type":"callback"},{"doc":"The default implementation for setup_queue/2 callback.","ref":"RMQ.Consumer.html#setup_queue/2","title":"RMQ.Consumer.setup_queue/2","type":"function"},{"doc":"Does all the job on preparing the queue.Whenever you need full control over configuring the queue you can implement this callback and use AMQP library directly.See setup_queue/2 for the default implementation.","ref":"RMQ.Consumer.html#c:setup_queue/2","title":"RMQ.Consumer.setup_queue/2","type":"callback"},{"doc":"RPC via RabbitMQ.In short, it's a GenServer which implements a publisher and a consumer at once.You can read more about how this works in the tutorial.Configuration:connection - the connection module which implements RMQ.Connection behaviour;:queue - the queue name to which the module will be subscribed for consuming responses. Defaults to &quot;&quot; which means the broker will assign a name to a newly created queue by itself;:exchange - the exchange name to which :queue will be bound. Please make sure the exchange exist. Defaults to &quot;&quot; - the default exchange;:consumer_tag - a consumer tag for :queue. Defaults to the current module name;:publishing_options - any valid options for AMQP.Basic.publish/5 except reply_to, correlation_id, content_type - these will be set automatically and cannot be overridden. Defaults to [];:reconnect_interval - a reconnect interval in milliseconds. It can be also a function that accepts the current connection attempt as a number and returns a new interval. Defaults to 5000.ExampleApplication 1:defmodule MyApp.RemoteResource do use RMQ.RPC, publishing_options: [app_id: &quot;MyApp&quot;] def find_by_id(id) do call(&quot;remote-resource-finder&quot;, %{id: id}) end endApplication 2:defmodule MyOtherApp.Consumer do use RMQ.Consumer, queue: &quot;remote-resource-finder&quot; @impl RMQ.Consumer def consume(chan, payload, meta) do response = payload |&gt; Jason.decode!() |&gt; Map.fetch!(&quot;id&quot;) |&gt; MyOtherApp.Resource.get() |&gt; Jason.encode!() AMQP.Basic.publish(chan, meta.exchange, meta.reply_to, response, correlation_id: meta.correlation_id ) AMQP.Basic.ack(chan, meta.delivery_tag) end end","ref":"RMQ.RPC.html","title":"RMQ.RPC","type":"behaviour"},{"doc":"Performs a call against the given module.Here options is a keyword list which will be merged into :publishing_options during the call and timeout is the timeout in milliseconds for the inner GenServer call.The payload will be encoded by using Jason.encode!/1.","ref":"RMQ.RPC.html#call/5","title":"RMQ.RPC.call/5","type":"function"},{"doc":"A callback for dynamic configuration.Will be called before setup_queue/2.","ref":"RMQ.RPC.html#c:config/0","title":"RMQ.RPC.config/0","type":"callback"},{"doc":"The default implementation for setup_queue/2 callback.","ref":"RMQ.RPC.html#setup_queue/2","title":"RMQ.RPC.setup_queue/2","type":"function"},{"doc":"Does all the job on preparing the queue.Whenever you need full control over configuring the queue you can implement this callback and use AMQP library directly.See setup_queue/2 for the default implementation.","ref":"RMQ.RPC.html#c:setup_queue/2","title":"RMQ.RPC.setup_queue/2","type":"callback"},{"doc":"RMQ - RabbitMQ tools. A set of handy tools for working with RabbitMQ in Elixir projects. Based on AMQP library.It includes:RMQ.ConnectionRMQ.ConsumerRMQ.RPQ","ref":"readme.html","title":"RMQ - RabbitMQ tools.","type":"extras"},{"doc":"The package can be installed by adding rmq to your list of dependencies in mix.exs:def deps do [ {:rmq, &quot;~&gt; 0.2.0&quot;} ] end","ref":"readme.html#installation","title":"RMQ - RabbitMQ tools. - Installation","type":"extras"},{"doc":"A GenServer which provides a robust connection to the RabbitMQ server.Usagedefmodule MyApp.RabbitConnection do use RMQ.Connection, otp_app: :my_app, uri: &quot;amqp://localhost&quot;, connection_name: to_string(__MODULE__) endMeant to be started under the application's supervision tree as follows:defmodule MyApp.Application do use Application def start(_type, _args) do children = [ MyApp.RabbitConnection # ... ] opts = [strategy: :one_for_one, name: MyApp.Supervisor] Supervisor.start_link(children, opts) end end Options:uri - an AMQP URI. Defaults to &quot;amqp://localhost&quot;;:connection_name - a RabbitMQ connection name. Defaults to :undefined;:reconnect_interval - a reconnect interval in milliseconds. It can be also a function that accepts the current connection attempt as a number and returns a new interval. Defaults to 5000;other options for AMQP.Connection.open/3.","ref":"readme.html#rmq-connection","title":"RMQ - RabbitMQ tools. - RMQ.Connection","type":"extras"},{"doc":"RabbitMQ Consumer.Usagedefmodule MyApp.Consumer do use RMQ.Consumer, queue: &quot;my-app-consumer-queue&quot;, exchange: {:direct, &quot;my-exchange&quot;} @impl RMQ.Consumer def consume(chan, payload, meta) do # do something with the payload ack(chan, meta.delivery_tag) end end # or with dynamic configuration defmodule MyApp.Consumer2 do use RMQ.Consumer @impl RMQ.Consumer def config do [ queue: System.fetch_env!(&quot;QUEUE_NAME&quot;), reconnect_interval: fn attempt -&gt; attempt * 1000 end, ] end @impl RMQ.Consumer def consume(chan, payload, meta) do # do something with the payload ack(chan, meta.delivery_tag) end endOptions:connection - the connection module which implements RMQ.Connection behaviour. Defaults to RMQ.Connection;:queue - the name of the queue to consume. Will be created if does not exist;:exchange - the name of the exchange to which queue should be bound. Also accepts two-element tuple {type, name}. Defaults to &quot;&quot;;:routing_key - queue binding key. Defaults to queue; Will be created if does not exist. Defaults to &quot;&quot;;:dead_letter - defines if the consumer should setup deadletter exchange and queue. Defaults to true;:dead_letter_queue - the name of dead letter queue. Defaults to &quot;\#{queue}_error&quot;;:dead_letter_exchange - the name of the exchange to which dead_letter_queue should be bound. Also accepts two-element tuple {type, name}. Defaults to &quot;\#{exchange}.dead-letter&quot;;:dead_letter_routing_key - routing key for dead letter messages. Defaults to queue;:concurrency - defines if consume/3 callback should be called in a separate process. Defaults to true;:prefetch_count - sets the message prefetch count. Defaults to 10;:consumer_tag - consumer tag. Defaults to a current module name;:reconnect_interval - a reconnect interval in milliseconds. It can be also a function that accepts the current connection attempt as a number and returns a new interval. Defaults to 5000;","ref":"readme.html#rmq-consumer","title":"RMQ - RabbitMQ tools. - RMQ.Consumer","type":"extras"},{"doc":"RPC via RabbitMQ.Usagedefmodule MyApp.RemoteResource do use RMQ.RPC, publishing_options: [app_id: &quot;MyApp&quot;] def find_by_id(id) do call(&quot;remote-resource-finder&quot;, %{id: id}, [message_id: &quot;msg-123&quot;], 10_000) end def list_all() do call(&quot;remote-resource-list-all&quot;) end endOptions:connection - the connection module which implements RMQ.Connection behaviour;:queue - the queue name to which the module will be subscribed for consuming responses. Defaults to &quot;&quot; which means the broker will assign a name to a newly created queue by itself;:exchange - the exchange name to which :queue will be bound. Please make sure the exchange exist. Defaults to &quot;&quot; - the default exchange;:consumer_tag - a consumer tag for :queue. Defaults to the current module name;:publishing_options - any valid options for AMQP.Basic.publish/5 except reply_to, correlation_id, content_type - these will be set automatically and cannot be overridden. Defaults to [];:reconnect_interval - a reconnect interval in milliseconds. It can be also a function that accepts the current connection attempt as a number and returns a new interval. Defaults to 5000.","ref":"readme.html#rmq-rpc","title":"RMQ - RabbitMQ tools. - RMQ.RPC","type":"extras"}]